package main

import "fmt"
import "time"

func muh(start, done chan bool) {
    _ = <-start
    for i := 0; i < 10; i++ {
	fmt.Printf("muh\n")
	time.Sleep(15.e7)	// nanoseconds
    }
    done<-true
}

func maeh(start, done chan bool) {
    _ = <-start
    for i := 0; i < 10; i++ {
	fmt.Printf("maeh\n")
	time.Sleep(10.e7)
    }
    done<-true
}

func main() {
    var (
	done = make(chan bool)
	start = make(chan bool)
    )

    go muh(start, done)
    go maeh(start, done)
    fmt.Printf("starting in 1 sec ...\n")
    time.Sleep(1e9)
    start<- true
    start<- true
    // wait until both are ready
    <-done
    <-done
    fmt.Printf("... both are finished\n")
}
